scala.tools.nsc.symtab.classfile.ICodeReader

# LinearCode

#### class LinearCode extends AnyRef

Source
  ICodeReader.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. LinearCode
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new LinearCode()

### Type Members

1. #### abstract class DupX extends Global.icodes.Instruction

   Duplicate and exchange pseudo-instruction.

   Duplicate and exchange pseudo-instruction. Should be later replaced by proper ICode

2. #### case class LCJUMP(success: Int, failure: Int, cond: Global.icodes.TestOp, kind: Global.icodes.TypeKind) extends LazyJump with Product with Serializable

3. #### case class LCZJUMP(success: Int, failure: Int, cond: Global.icodes.TestOp, kind: Global.icodes.TypeKind) extends LazyJump with Product with Serializable

4. #### case class LJUMP(pc: Int) extends LazyJump with Product with Serializable

5. #### case class LSWITCH(tags: List[List[Int]], targets: List[Int]) extends LazyJump with Product with Serializable

6. #### abstract class LazyJump extends Global.icodes.Instruction

   Base class for branch instructions that take addresses.

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from LinearCode to any2stringadd[LinearCode] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (LinearCode, B)

   Implicit information
     This member is added by an implicit conversion from LinearCode to ArrowAssoc[LinearCode] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### object DUP2_X1 extends DupX with Product with Serializable

7. #### object DUP2_X2 extends DupX with Product with Serializable

8. #### object DUP_X1 extends DupX with Product with Serializable

9. #### object DUP_X2 extends DupX with Product with Serializable

10. #### final def asInstanceOf[T0]: T0

    Definition Classes
      Any

11. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

12. #### var containsDUPX: Boolean

13. #### var containsEHs: Boolean

14. #### var containsInvokeDynamic: Boolean

15. #### var containsNEW: Boolean

16. #### def emit(i: Global.icodes.Instruction): Unit

17. #### def ensuring(cond: (LinearCode) ⇒ Boolean, msg: ⇒ Any): LinearCode

    Implicit information
      This member is added by an implicit conversion from LinearCode to Ensuring[LinearCode] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: (LinearCode) ⇒ Boolean): LinearCode

    Implicit information
      This member is added by an implicit conversion from LinearCode to Ensuring[LinearCode] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: Boolean, msg: ⇒ Any): LinearCode

    Implicit information
      This member is added by an implicit conversion from LinearCode to Ensuring[LinearCode] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean): LinearCode

    Implicit information
      This member is added by an implicit conversion from LinearCode to Ensuring[LinearCode] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def enterParam(idx: Int, kind: Global.icodes.TypeKind): Global.icodes.Local

    add a method param with the given index.

22. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

23. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

24. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

25. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from LinearCode to StringFormat[LinearCode] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

26. #### def freshLocal(kind: Global.icodes.TypeKind): Global.icodes.Local

    Invent a new local, with a new index value outside the range of the original method.

27. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

28. #### def getLocal(idx: Int, kind: Global.icodes.TypeKind): Global.icodes.Local

29. #### def getLocal(idx: Char, kind: Global.icodes.TypeKind): Global.icodes.Local

    Return the local at given index, with the given type.

30. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

31. #### val instrs: ListBuffer[(Int, Global.icodes.Instruction)]

32. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

33. #### val jmpTargets: Set[Int]

34. #### val locals: Map[Int, List[(Global.icodes.Local, Global.icodes.TypeKind)]]

35. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

36. #### final def notify(): Unit

    Definition Classes
      AnyRef

37. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

38. #### def resolveDups(): Unit

39. #### def resolveNEWs(): Unit

    Recover def-use chains for NEW and initializers.

40. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

41. #### def toBasicBlock: Global.icodes.Code

    Break this linear code in basic block representation As a side effect, it sets the `code` field of the current

42. #### def toString(): String

    Definition Classes
      LinearCode → AnyRef → Any

43. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

46. #### def →[B](y: B): (LinearCode, B)

    Implicit information
      This member is added by an implicit conversion from LinearCode to ArrowAssoc[LinearCode] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from LinearCode to any2stringadd[LinearCode]

### Inherited by implicit conversion StringFormat from LinearCode to StringFormat[LinearCode]

### Inherited by implicit conversion Ensuring from LinearCode to Ensuring[LinearCode]

### Inherited by implicit conversion ArrowAssoc from LinearCode to ArrowAssoc[LinearCode]

### Ungrouped